#ifndef SYSTEM_H
#define SYSTEM_H

#include <SDL.h>

// mouse buttons
#define BUT_LEFT    (1 << 0)
#define BUT_RIGHT   (1 << 1)

class CSystem
{
public:
    CSystem();

    void    wait(Uint32 ms);
    void    processEvents();
    bool    isQuitRequested();

    void    StartPerfCounter();
    float   StopPerfCounter();

    Uint8   buttons;        // true while a button is pressed
    Uint8   buttonsDown;    // true only at the frame the button is pressed
    Uint8   buttonsUp;      // true only at the frame the button is released
    int     mouseX;
    int     mouseY;

private:
    bool    mQuitRequest;
    Uint64  mPerfCounter;
};

extern CSystem sys;

#endif // SYSTEM_H
