#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"


#define SCREEN_WIDTH    600
#define SCREEN_HEIGHT   600

CBlob::CBlob()
{
    pos.x = rand() % SCREEN_WIDTH;
    pos.y = rand() % SCREEN_HEIGHT;

    radius = 50 + (rand() % 100);
}

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Metaballs 3", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    srand(time(NULL));

    const int nbBlobs = 6;
    CBlob* blobs = new CBlob[nbBlobs];

    while (sys.isQuitRequested() == false)
    {
        for (int y = 0; y < SCREEN_HEIGHT; y++)
            for (int x = 0; x < SCREEN_HEIGHT; x++)
            {
                Vec2f p(x, y);

                float power = 0;

                for (int i = 0; i < nbBlobs; i++)
                {
                    Vec2f delta = p - blobs[i].pos;
                    float dist = blobs[i].radius - delta.mag();

                    if (dist < 0)
                        dist = 0;

                    power += dist;
                }

                if (power > 255)
                    power = 255;

                int c = (int)power;
                gfx.setPixel(x, y, Color(c, c, c));
            }

        gfx.render();
        sys.processEvents();
    }

    delete[] blobs;
    gfx.quit();

    return EXIT_SUCCESS;
}
